#include <stdio.h>
#include <math.h>
#include <string.h>
#include <queue>
using namespace std;

#define N 800
#define M 1200

int x[N],y[N];
int n,m, a,b;
long c, total;
bool exist[N][N];
bool done[N];
priority_queue<pair<long,pair<int,int> > > q;
char buf[100];

long cost(int a, int b) {
	if (exist[a][b]) return 0;
	return (x[a]-x[b])*(x[a]-x[b]) + (y[a]-y[b])*(y[a]-y[b]);
}

void show() {
	priority_queue<pair<long,pair<int,int> > > q2;
	while (!q.empty()) {
		printf("%s%ld %d %d", q2.empty()?"":"| ", -q.top().first, q.top().second.first, q.top().second.second);
		q2.push(q.top()); q.pop();
	}
	printf("\n");
	q = q2;
}

int main() {
	int cases;
	scanf("%d",&cases);
	while(cases--) {
		memset(exist,0,N*N*sizeof(bool));
		memset(done,0,N*sizeof(bool));
		

		scanf("%d", &n);
		for (int i=0; i<n; i++) scanf("%d %d", x+i, y+i);

		scanf("%d", &m);
		for (int i=0; i<m; i++) { 
			scanf("%d %d", &a,&b);		
			exist[a-1][b-1] = exist[b-1][a-1] = true;
		}

		total=0;
		q.push(make_pair(0,make_pair(0,0)));
		while(!q.empty()) {
			//show();
			pair<long,pair<int,int> > cab = q.top(); q.pop();
			c=-cab.first; a=cab.second.first; b=cab.second.second;
			if (done[b]) continue;
			//printf("done %d; %d (%d %d) -> %d (%d %d); %ld\n", b, a, x[a], y[a], b, x[b], y[b], c);
			done[b] = true; exist[a][b]=exist[b][a]=false;
			total += c;
			if (c>0) printf("%d %d\n", a+1, b+1);
			for (int x=0; x<n; x++) {
				if (!done[x]) {
					q.push(make_pair(-cost(b,x),make_pair(b,x)));
				}
			}
		}

		if (total==0) printf("No new highways need\n");

		if (cases) printf("\n");
	}
}
