#include <stdio.h>
#include <math.h>
#include <string.h>
#include <queue>
using namespace std;

#define N 800

int x[N],y[N],p[N]; // p=parent for union-find
int n,m, a,b,c;
priority_queue<pair<long,pair<int,int> > > q;

long cost(int a, int b) {
	return (x[a]-x[b])*(x[a]-x[b]) + (y[a]-y[b])*(y[a]-y[b]);
}

int root(int i) {
	if (p[i]==i) return i;
	return (p[i]=root(p[i]));
}

int main() {
	int cases;
	scanf("%d",&cases);
	while(cases--) {
		scanf("%d", &n);
		for (int i=0; i<n; i++) { p[i]=i; scanf("%d %d", x+i, y+i); }

		scanf("%d", &m);
		for (int i=0; i<m; i++) { 
			scanf("%d %d", &a,&b);		
			p[root(b-1)] = root(a-1);
		}

		for (int i=0; i<n; i++) for (int j=0; j<i; j++) {
			q.push(make_pair(-cost(i,j),make_pair(i,j))); 
		}

		bool build=false;
		while(!q.empty()) {
			pair<long,pair<int,int> > cab = q.top(); q.pop();
			c=-cab.first; a=cab.second.first; b=cab.second.second;
			if (root(a)==root(b)) continue;
			build = true;
			p[root(b)] = root(a);
			printf("%d %d\n", a+1, b+1);
		}

		if (!build) printf("No new highways need\n");

		if (cases) printf("\n");
	}
}
